// Code generated by protoc-gen-go. DO NOT EDIT.
// source: broker/v1/config/service_plan.proto

package istio_broker_v1_config

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// ServicePlan defines the type of services available to Istio service
// consumers.  One or more services are included in a plan. The plan is flexible
// and subject to change along with business requirements.
type ServicePlan struct {
	// Required. Public plan information.
	Plan *CatalogPlan `protobuf:"bytes,1,opt,name=plan" json:"plan,omitempty"`
	// Required. List of the Keys of serviceclass config instance
	// that are included in the plan.
	// ServiceClass is a type of CRD resource.
	Services []string `protobuf:"bytes,2,rep,name=services" json:"services,omitempty"`
}

func (m *ServicePlan) Reset()                    { *m = ServicePlan{} }
func (m *ServicePlan) String() string            { return proto.CompactTextString(m) }
func (*ServicePlan) ProtoMessage()               {}
func (*ServicePlan) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *ServicePlan) GetPlan() *CatalogPlan {
	if m != nil {
		return m.Plan
	}
	return nil
}

func (m *ServicePlan) GetServices() []string {
	if m != nil {
		return m.Services
	}
	return nil
}

// CatalogPlan defines listing information for this service plan within the
// exposed catalog.  The message is a subset of OSBI plan fields defined in
// https://github.com/openservicebrokerapi
type CatalogPlan struct {
	// Required. Public service plan name.
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// Required. Public unique service plan guid.
	Id string `protobuf:"bytes,2,opt,name=id" json:"id,omitempty"`
	// Required. Public short service plan description.
	Description string `protobuf:"bytes,3,opt,name=description" json:"description,omitempty"`
}

func (m *CatalogPlan) Reset()                    { *m = CatalogPlan{} }
func (m *CatalogPlan) String() string            { return proto.CompactTextString(m) }
func (*CatalogPlan) ProtoMessage()               {}
func (*CatalogPlan) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{1} }

func (m *CatalogPlan) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *CatalogPlan) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *CatalogPlan) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func init() {
	proto.RegisterType((*ServicePlan)(nil), "istio.broker.v1.config.ServicePlan")
	proto.RegisterType((*CatalogPlan)(nil), "istio.broker.v1.config.CatalogPlan")
}

func init() { proto.RegisterFile("broker/v1/config/service_plan.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 192 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x6c, 0x8f, 0x41, 0xaa, 0x83, 0x30,
	0x10, 0x86, 0x31, 0xca, 0xe3, 0x39, 0x81, 0xb7, 0xc8, 0xe2, 0x11, 0xba, 0x12, 0xdd, 0xb8, 0x8a,
	0xd8, 0x2e, 0x7a, 0x80, 0x5e, 0xa0, 0xe8, 0x01, 0x4a, 0xd4, 0x54, 0x86, 0xda, 0x44, 0x92, 0xe0,
	0xf9, 0x8b, 0xb1, 0x14, 0x17, 0xdd, 0xcd, 0xfc, 0xf3, 0x7d, 0xfc, 0x0c, 0x14, 0x9d, 0x35, 0x0f,
	0x65, 0xab, 0xa5, 0xae, 0x7a, 0xa3, 0xef, 0x38, 0x56, 0x4e, 0xd9, 0x05, 0x7b, 0x75, 0x9b, 0x27,
	0xa9, 0xc5, 0x6c, 0x8d, 0x37, 0xec, 0x1f, 0x9d, 0x47, 0x23, 0x36, 0x54, 0x2c, 0xb5, 0xd8, 0xd0,
	0xbc, 0x03, 0xda, 0x6e, 0xf4, 0x75, 0x92, 0x9a, 0x9d, 0x21, 0x59, 0x25, 0x1e, 0x65, 0x51, 0x49,
	0x8f, 0x85, 0xf8, 0x6e, 0x89, 0x8b, 0xf4, 0x72, 0x32, 0xe3, 0xaa, 0x34, 0x41, 0x60, 0x07, 0xf8,
	0x7d, 0xb7, 0x3a, 0x4e, 0xb2, 0xb8, 0x4c, 0x9b, 0xcf, 0x9e, 0xb7, 0x40, 0x77, 0x02, 0x63, 0x90,
	0x68, 0xf9, 0x54, 0xa1, 0x23, 0x6d, 0xc2, 0xcc, 0xfe, 0x80, 0xe0, 0xc0, 0x49, 0x48, 0x08, 0x0e,
	0x2c, 0x03, 0x3a, 0x28, 0xd7, 0x5b, 0x9c, 0x3d, 0x1a, 0xcd, 0xe3, 0x70, 0xd8, 0x47, 0xdd, 0x4f,
	0xf8, 0xeb, 0xf4, 0x0a, 0x00, 0x00, 0xff, 0xff, 0xfa, 0x21, 0xa6, 0x48, 0xfe, 0x00, 0x00, 0x00,
}
